package funktio.integroi;

import demo.d8.*;

import fi.jyu.mit.graphics.*;
import static java.lang.Math.PI;

import fi.jyu.mit.graphics.FunctionRR;


/**
 * Esimerkki funktion piirtämisestä.
 * Piirtää sin-käyrän ja sille "integrointia" vastaavat pylväät 
 * @author vesal
 * @version 13.3.2012
 */
public class SinKuva {

    /**
     * Piirtää numeerista integrointia vastaavat pylväät funktion kohdalle
     * @param space avaruus, johon pylväitä piirretään
     * @param f      funktio, jolle pylväät piirretään
     * @param x1     alkupiste
     * @param x2     loppupiste
     * @param tiheys kuinka monta pylvästä piirretään
     */
    public static void piirraPylvaat(Space space, FunctionRR f, double x1, double x2, double tiheys) {
        double dx = (x2- x1)/tiheys;

        for (double x=x1+dx/2 ; x<x2; x+=dx) {
            Pylvas pylvas = new Pylvas(dx,f.f(x),0);
            pylvas.move(x-dx/2, 0, 0);
            space.add(pylvas);
        }
    }

    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        FunctionRR f = SinFun.sin;
        
        double x1=0,x2=PI;
        double dx = 0.2;
        
        Space space = new Space();

        EasyWindow window = new EasyWindow();
        window.setSpace(space);
        
        window.scale(x1-dx,-0.2,x2+dx,1.2);
        window.addAxis(10, 10, 10);
        space.add(new FunctionMapRR(f,x1,x2,0));
        
        piirraPylvaat(space, f,x1,x2, 10);
/*
        FunctionRR f2 = new Polynom(0.2,1,2);
        space.add(new FunctionMapRR(f2,x1,x2,0));
        EasyWindow window2 = new EasyWindow();
        window2.setSpace(space);
        window2.showWindow();
        window2.scale(-10,-10,10,10);
        new Rotator(window2,Axis.Z,1,20);
*/
    }

}
