package lambda;

import java.util.*;
import java.util.stream.*;

@SuppressWarnings("javadoc")
public class StreamMalli {

    public static void main(String[] args) {
        List<Integer> luvut = Arrays.asList(1, 3, 6, 22, 4, -3);
        System.out.println(luvut);
        List<Integer> neliot =
            luvut.stream().map(n -> n*n).collect(Collectors.toList());
        System.out.println(neliot);

        // Seuraavassa sum saa ensin arvon 0, sitten kutsutaan lambdaa sum,n
        int summa = luvut.stream().reduce(0, (sum,n) -> sum + n);
        int tulo = luvut.stream().reduce(1, (vanhatulo,n) -> vanhatulo * n);
        int suurin = luvut.stream().reduce(Integer.MIN_VALUE,
                                  (ennatys,n) -> n > ennatys ? n : ennatys);
        // Luokissa on myös useita valmiita funktoita, kuten esim max ja min
        int pienin = luvut.stream().reduce(Integer.MAX_VALUE, Integer::min);

        System.out.printf("Summa %d, tulo = %d, [%d,%d]\n",
                             summa, tulo, pienin, suurin);

        luvut.stream().filter(n -> n < 5).forEach(n -> System.out.print(n + " "));
        System.out.println();
    }
}